<%@page import="com.sas.oprisk.server.ConfigDataProperties"%>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="ISO-8859-1"%>
<%@page import="com.sas.oprisk.framework.server.services.FrameworkServiceLocator"%>
<%@page import="com.sas.ui.cpb3.repo.*" %>
<%@page import="com.sas.fsd.shared.util.*" %>
<%@page import="com.sas.oprisk.framework.server.*" %>
<%@ taglib uri="http://www.sas.com/taglib/sas-html" prefix="sas-html" %>
<%
   boolean appSwitcherEnabled = true;
   if ( request.getParameter("appSwitcherDisabled") != null) {
       appSwitcherEnabled = false;
   }
   
   String coreScript = "sap-ui-core.js";
   if (FrameworkServiceLocator.isDevelopmentMode()) {
      coreScript = "sap-ui-core-dbg.js";     
   }
   
   ICPBService service = CPBServiceUtil.getInstance().getCPBService();
   String appNameOrig = service.getBundle(FrameworkServiceLocator.getLocale()).getString("application.title.txt");
   String appName = StringUtil.escapeJSForHTML(appNameOrig);
   String appTitle = StringUtil.escapeHTML(appNameOrig);
   boolean isMRM = FrameworkConstants.DEFAULT_SSC_ID.equals("MRM");
   String appId = isMRM ? "MRM_HUB_Home" : "RGF_HUB_Home";
   boolean GLOBAL_SEARCH_ON=ConfigDataProperties.isSolrEnabled();
%>
<!DOCTYPE html>
<script type="text/javascript" src="resources/sap/ui/thirdparty/signals.js"></script>
<script type="text/javascript" src="resources/sap/ui/thirdparty/hasher.js"></script>
<style>
.gshHeader {
  border-color: #ec66eb;
  font-size: 11;
  margin-bottom: 4;
}
<%if(!GLOBAL_SEARCH_ON){%>
body #MRM_HUB_Home_appContainer_banner-searchField{
   display:none;
}
<%}%>
</style>
<sas-html:Application
        applicationName="<%=appName %>"
        applicationId="<%=appId%>"
        applicationSwitcherEnabled="<%=appSwitcherEnabled%>"        
        jsViewClass="sas.ui.cpb3.nav.MainShell"
        openUiCoreScript="<%=coreScript%>"
        configFile="sas/risk/mrm/config.js">
    <sas-html:head-content>
        <meta http-equiv="X-UA-Compatible" content="IE=edge"></meta>
        <meta name="apple-mobile-web-app-capable" content="yes">
        <script type="text/javascript" src="resources/sas/risk/mrm/signals_hasher.js"></script>
        <script type="text/javascript" src="resources/underscore-min.js"></script>
        <script type="text/javascript" src="resources/go.js"></script>
        <script type="text/javascript" src="resources/ckeditor/ckeditor.js"></script>
        <script type="text/javascript" src="resources/sap/ui/thirdparty/d3.js"></script>
        <title><%=appTitle%></title>
    </sas-html:head-content>
    <script>
      var appId="<%=appId%>";
      sap.ui.getCore().attachInit(function(){
         jQuery.sap.require("sas.risk.mrm.library");/*make sure all libs get loaded in the right order*/
         jQuery.sap.require("sas.risk.mrm.util.MRMFixes");/*patch it all up*/
         jQuery.sap.require("sas.ui.cpb3.nav.HashChanger");/*hacks up the hashchanger and loads ours*/
         /*prepare all the routes*/
         jQuery.sap.require("sas.risk.mrm.util.RouteUtil");
         sas.risk.mrm.util.RouteUtil.getRoutes().done(function(routes){
         	/*Set the application Id we are running*/
         	sas.risk.mrm.util.MRMUtil.setAppId(appId);
            /*register a router with the routes and target view*/
            var router = new sas.ui.cpb3.nav.Router(routes,{
               targetControl: "MainShellArea",
               targetAggregation: "items",
               viewType: sap.ui.core.mvc.ViewType.JS,
               viewPath: "sas.ui.cpb3.nav",
               clearTarget: true
            });
         	/*initialize Shell*/
         	sas.ui.cpb3.model.CpbShellModel.getInstance().initialize();
         	/*initialize CPB singletons*/
            jQuery.sap.require("sas.risk.mrm.data.MRMObjectModel");
            jQuery.sap.require("sas.risk.mrm.api.MRMCpbObjectAPI");
            jQuery.sap.require("sas.risk.mrm.api.MRMCpbQueryAPI");
            jQuery.sap.require("sas.risk.mrm.api.MRMUIContextAPI");
         	/*register Router*/
            router.register("router");
         	/*Load User Preferences*/
            $.when(
            		sas.risk.mrm.api.CommonAPI.loadCPB3Resources(),
                  sas.risk.mrm.api.CommonAPI.loadUserDetails(),
                  sas.risk.mrm.api.CommonAPI.loadTaskTypes(),
                  sas.risk.mrm.api.UtilsAPI.getVisibleRowCounts()
            ).done(function(){
               sas.ui.cpb3.CpbUtil.setLocale(sas.risk.mrm.util.MRMUtil.getLocale());//this one requires loadUserDetails to complete
               sas.ui.cpb3.CpbUtil.setBundle(sas.risk.mrm.util.MRMUtil.getBundle());//this one requires loadCPB3Resources to complete
               jQuery.sap.require("sas.risk.slimtable.util.SlimTableUtil");
               sas.risk.slimtable.util.SlimTableUtil.setBundle(sas.risk.mrm.util.MRMUtil.getBundle());
               sas.risk.slimtable.util.SlimTableUtil.setLocale(sas.risk.mrm.util.MRMUtil.getLocale());
               /*Register Factories*/
               jQuery.sap.require("sas.risk.mrm.components.ComponentFactory");
               jQuery.sap.require("sas.risk.mrm.meta.ColumnFormatterFactory");
               /*Hooking into HTML Commons: Global Search*/
               <%if(GLOBAL_SEARCH_ON){%>
               sas.risk.mrm.util.MRMUtil.takeoverGlobalSearchField();
               <%}%>
               var userDetails=sas.risk.mrm.api.CommonAPI.getUserDetails();
               var banner=sas.risk.mrm.util.MRMUtil.getBanner();
               /*Hooking into HTML Commons: Help*/
               banner.setHelpUrl(userDetails.getHelpUrl());
               /*Hooking into HTML Commons: Impersonation*/
               if(userDetails.getImpersonatedName()){
                  banner.setUserName(userDetails.getImpersonatedName()+ " ("+userDetails.getName()+")");
               }
               /*Guard losing changes on window close*/
               jQuery(window).bind("beforeunload", function(e){
                  if(sas.risk.mrm.util.MRMUtil.hasUnsavedChanges()){
                     var rb = sas.risk.mrm.util.MRMUtil.getBundle();
                     var message=rb.getText("form.unsaved.warning.txt");
                     e.returnValue=message;
                     return message;            
                  }
               });
               /*get ready in case of a timeout*/
               sas.risk.mrm.util.MRMUtil.handleTimeout();
               /*initialize Router*/
               sas.ui.cpb3.nav.Router.getRouter().initialize();
               /*Hooking into logout link -- needs first route to be processed to determine if it is a child tab*/
               var menuButton=sas.risk.mrm.util.MRMUtil.getLogoutLink();
               if(sas.risk.mrm.util.MRMUtil.isMainTab()){//catch logout link event
                  menuButton.getMenu().detachItemSelected(sas.risk.mrm.util.MRMUtil.closeAllChildTabs);
                  menuButton.getMenu().attachItemSelected(sas.risk.mrm.util.MRMUtil.closeAllChildTabs);
               }else{//hide logout link and global search when we are in a new tab
                  menuButton.setVisible(false);
                  var globalSearch=sas.risk.mrm.util.MRMUtil.getGlobalSearchField();
                  if(globalSearch){
                  	globalSearch.setVisible(false);//getting reverted later by unknonwn call
                  	globalSearch.setVisible=function(){};
                  }
                  sas.risk.mrm.util.MRMUtil.registerChildTab();
               }
            });
         });
      });
    </script>
    <script type="text/javascript" src="resources/sas/risk/mrm/init.js"></script>
    <link rel="stylesheet" href="style/customStyles.css">
</sas-html:Application>
