jQuery.sap.declare("sas.risk.mrm.components.ContentManagementComponent");
jQuery.sap.require("sas.ui.cpb3.components.AComponentMixin");
jQuery.sap.require("sas.hc.m.List");
jQuery.sap.require("sap.m.ScrollContainer");
jQuery.sap.require("sas.hc.m.StandardListItem");
jQuery.sap.require("sap.ui.model.json.JSONModel");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.CustomListItem");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.risk.mrm.util.MRMUtil");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.m.Dialog");
jQuery.sap.require("sas.hc.ui.commons.Label");
jQuery.sap.require("sas.hc.ui.commons.TextField");
jQuery.sap.require("sas.hc.ui.commons.form.SimpleForm");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayout");
jQuery.sap.require("sas.risk.common.layout.flexlayout.FlexLayoutData");
jQuery.sap.require("sas.hc.m.Heading");
jQuery.sap.require("sas.risk.mrm.widget.MRMTable");
jQuery.sap.require("sas.risk.mrm.util.DialogManager");
jQuery.sap.require("sas.risk.mrm.api.ContentManagementAPI");
jQuery.sap.require("sas.risk.mrm.meta.formatter.FileSizeFormatter");
jQuery.sap.require("sas.risk.slimtable.util.RowActionUtil");
jQuery.sap.require("sas.risk.mrm.widget.menu.ColumnsItem");
jQuery.sap.require("sas.risk.mrm.widget.menu.CustomizationInfoItem");
jQuery.sap.require("sas.ui.cpb3.WidgetBindingUtil");
jQuery.sap.require("sas.ui.cpb3.CpbUtil");
jQuery.sap.require("sas.risk.common.widgets.Button");

sap.ui.layout.VerticalLayout.extend("sas.risk.mrm.components.ContentManagementComponent",sas.ui.cpb3.components.AComponentMixin.mixinMeta({
   metadata : {
       properties : {
           "meta" : {type : "any"},
           "visibleRows" : {type:"int"},
           formattingKey:{type:"any"}
       },
       events:{
           change:{}
       }
   },
   constructor : function() {
		sas.risk.common.utils.CompositeUtil.addComposite(this,"cpbVisible",this,"visible");
		sap.ui.layout.VerticalLayout.apply(this,arguments);
	},
   renderer : "sap.ui.layout.VerticalLayoutRenderer"
}));
sas.ui.cpb3.components.AComponentMixin.mixin(sas.risk.mrm.components.ContentManagementComponent);

sas.risk.mrm.components.ContentManagementComponent.prototype.setMeta=function(meta) {
   this.setProperty("meta", meta);
   this.meta = meta;

   var model=this.getModel("cpb_data");
   if (model)
   {
      this.initializeTable(model);
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.setCpbRequired=function(value){
    this.setProperty("cpbRequired",value);
    if(this.table){
        this.table.setRequired(value);
    }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.setCpbValue=function(value){
   this.setProperty("cpbValue",value);
   
   var model=this.getModel("cpb_data");
   if (this.meta)
   {
      this.initializeTable(model);
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.initializeTable=function(model){
   if (!this.table) {
      var that = this;
      this.setWidth("100%");      
      this.createTable();
      this.addContent(this.table);

      if (model.getData("cpb_data")["NEVERBEENSAVED"])
      {
         if (this.meta.initialEntries && this.meta.initialEntries.length > 0)
         {
            that.table.setBusyIndicatorDelay(0);
            that.table.setBusy(true);
            
            var defsArray = [];
            for (var i = 0; i < this.meta.initialEntries.length; i++)
            {
               var def = sas.risk.mrm.api.ContentManagementAPI.initializeAttachment(model, this.meta.groupNumber, this.meta.initialEntries[i]);
               if (def != null)
               {
                  defsArray.push(def);
               }
            }
            
            $.when.apply($, defsArray).done(function() {
               that.table.doRefresh();
               that.table.setBusy(false);                
            });
         }
         else if (this.meta.initialRefresh)
         {
            that.table.setBusyIndicatorDelay(0);
            that.table.setBusy(true);
            var def = sas.risk.mrm.api.ContentManagementAPI.reloadAttachments(model, this.meta.groupNumber);
            def.done(function(){
               that.table.doRefresh();
               that.table.setBusy(false);
            });           
         }
      }
   }
}

sas.risk.mrm.components.ContentManagementComponent.prototype.onAfterRendering=function(value){
   this.rebuildActions();
}

sas.risk.mrm.components.ContentManagementComponent.prototype.shouldHandleRichText=function(){
	return !(this.getMeta().handleRichText === false);
};
sas.risk.mrm.components.ContentManagementComponent.prototype.rebuildActions=function() {
   var maxRows = this.meta.maxRows;
   if (maxRows){
      var rows = this.table.totalCount;
      if(rows >= maxRows){
      	this.addHTMLLink.setVisible(false);
      	this.addImplementationLink.setVisible(false);
      	this.addLink.setVisible(false);
      }else{
      	this.addHTMLLink.setVisible(this.testLinkVisibility("HTML"));
      	this.addImplementationLink.setVisible(this.testLinkVisibility("IMPL"));
      	this.addLink.setVisible(this.testLinkVisibility("BASE"));
      }
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.isAddImplementationLinkEnabled = function(){
	return (this.getMeta().remoteFileListingURL !== undefined)
			&& (this.getMeta().remoteFileTransferURL !== undefined);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.getTableTopActionsPlugin=function(){
	var that=this;
   //-- View Deleted Link --//
   this.viewDeletedLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.viewDeletedLink,
 		 icon:sas.icons.HC.VIEWITEM,
       press : function(evt) {
          var viewData={
         		 labelOverridePrefix: that.getLabelOverridePrefix(),
                meta:that.meta,
                model:this.getModel("cpb_data"),
                updateEnabled:that.getCpbEnabled(),
                title:that.meta.removedTitle,
                formattingKey:sas.risk.mrm.util.MRMUtil.buildDialogFormattingKey("ContentDeletedDialog",that.getCpbForm(),"ContentManagementComponent",that.getCpbName())
            };
            sas.risk.mrm.util.DialogManager.open("ContentDeletedDialog",viewData,that.refreshTableContent,that);
       }
   }).addStyleClass("MRMContentActionLink");
   this.viewDeletedLink.getEnabled=function(val){//viewDeletedLink should be always enabled irrespective of whether table is readonly or not
      return true;
   };
   
   //-- View History Link --//
   this.viewHistoryLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.viewHistoryLink,
       icon:sas.icons.HC.HISTORY,
       press : function(evt) {
           var viewData={
         		labelOverridePrefix: that.getLabelOverridePrefix(),
               meta:that.meta,
               model:this.getModel("cpb_data"),
               title:that.meta.historyTitle,
               formattingKey:sas.risk.mrm.util.MRMUtil.buildDialogFormattingKey("ContentHistoryDialog",that.getCpbForm(),"ContentManagementComponent",that.getCpbName())
           };
           sas.risk.mrm.util.DialogManager.open("ContentHistoryDialog",viewData);
       },
       visible: (this.meta.canUpdateContent !== false)
   }).addStyleClass("MRMContentActionLink");
   this.viewHistoryLink.getEnabled=function(val){//viewHistoryLink should be always enabled irrespective of whether table is readonly or not
      return true;
   };

   //-- Delete Link --//
   this.multiDeleteLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.deleteLink,
       icon:sas.icons.HC.REMOVEITEM,
       press : $.proxy(this.actionTargetDelete,this),
       enabled : false
   }).addStyleClass("MRMContentActionLink");

   //-- Add Link --//
   this.addLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.addLink,
       icon:sas.icons.HC.ADDITEM,
       press : $.proxy(this.actionTargetAdd,this),
       visible: this.testLinkVisibility("BASE")
   }).addStyleClass("MRMContentActionLink");
   
   //-- Add HTML Link --//
   this.addHTMLLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.addRichTextLink,
       icon:sas.icons.HC.FILE,
       press : $.proxy(this.actionTargetHTMLAdd,this),
       visible: this.testLinkVisibility("HTML")
   }).addStyleClass("MRMContentActionLink");
   
   //-- Add Model Implementation Link --//
   this.addImplementationLink = new sas.risk.common.widgets.Button({
       tooltip : that.meta.addImplementationLink,
       icon:sas.icons.HC.FILE,
       press : $.proxy(this.actionTargetImplementationAdd,this),
       visible: this.testLinkVisibility("IMPL")
   }).addStyleClass("MRMContentActionLink");
   
   this.tableTopActionsPlugin=new sas.risk.slimtable.plugins.TablePlugin({
     	position: sas.risk.slimtable.TableLayout.TOP_END,
   	items:[this.addHTMLLink, this.addImplementationLink, this.addLink, this.multiDeleteLink, this.viewHistoryLink, this.viewDeletedLink]
   });
   this.tableTopActionsPlugin.handleDisabled=function(){
   	that.multiDeleteLink.setVisible(false);
      that.addLink.setVisible(false);
   };
   return this.tableTopActionsPlugin;
};
sas.risk.mrm.components.ContentManagementComponent.prototype.testLinkVisibility = function(type) {
	switch(type){
		case "HTML":
			return this.shouldHandleRichText() && this.meta.showAddLink;
		case "IMPL":
			return this.isAddImplementationLinkEnabled() && this.meta.showAddLink;
		break;
		case "BASE":
		default:
			return !this.isAddImplementationLinkEnabled() && this.meta.showAddLink; //If Add Implementation link is enabled, then don't show add link
	}
};
sas.risk.mrm.components.ContentManagementComponent.prototype.createTable = function() {
   var that = this;
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   //TABLE
   this.table = new sas.risk.mrm.widget.MRMTable({
   	 formattingKey : this.getFormattingKey(),
       meta : that.meta.tableMeta,
       data : $.proxy(this.fetchData, this),
       clientSide : true,
       visibleRows : this.getVisibleRows(),
       showSelectionControls : true,
       multiSelect : true,
       hideActionColumnOnReadOnly: false, 
       enabled:this.getCpbEnabled(),
       required:this.getCpbRequired(),
       plugins:[this.getTableTopActionsPlugin(),
                new sas.risk.slimtable.plugins.Search(),
                new sas.risk.slimtable.plugins.Filter(),
                new sas.risk.slimtable.plugins.TableOptions({
               	  menuItems: this.getTableMenuItems()
                 }),
                new sas.risk.slimtable.plugins.Counter(),
                new sas.risk.slimtable.plugins.Pager()
       ]
   });
   this.table.attachRowSelect($.proxy(this.actionTableSelectionChanged,this));
   this.table.attachRowClick($.proxy(this.actionTableRowClicked,this));
   
   this.table.bindProperty("title", {
      path:"cpb_labels>/label"+that.getCpbLabel(),
      formatter:function(value){
          if(!value || !value.message){
              return that.getCpbLabel();
          }
          return value.message;
      }
   });
   this.table.setHelp(this.getCpbHelp());
   
   //ACTION COLUMN
   var actionColumn=sas.risk.slimtable.util.RowActionUtil.createActionColumn($.proxy(this.createActionMenuItems,this),this.table);
   this.table.addActionColumn(actionColumn);   
};

sas.risk.mrm.components.ContentManagementComponent.prototype.getTableMenuItems=function(){
	var menuItems=[new sas.risk.mrm.widget.menu.ColumnsItem()];
	var customizationInfoMeta=this.meta.tableMeta.customizationInfoMeta;
	if(customizationInfoMeta){
		var custInfoUrl="rest/utils/showCustomizationInfo/content/labelOverridePrefix/"+this.getLabelOverridePrefix();
		if (customizationInfoMeta.fileName) {
			custInfoUrl += "?fileName="+customizationInfoMeta.fileName;
		}
		menuItems.push(new sas.risk.mrm.widget.menu.CustomizationInfoItem({url:custInfoUrl,meta:customizationInfoMeta}));
	}
   return menuItems;
};

sas.risk.mrm.components.ContentManagementComponent.prototype.fetchData = function(query) {
   return sas.risk.mrm.api.ContentManagementAPI.fetchAttachments(this.getModel("cpb_data"),this.meta.groupNumber);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.refreshTableContent = function(e) {
   this.table.doRefresh();
   this.rebuildActions();
};

sas.risk.mrm.components.ContentManagementComponent.prototype.doCPBRefresh = function(){
   this.table.doRefresh();
   this.rebuildActions();
};

//CREATES
sas.risk.mrm.components.ContentManagementComponent.prototype.createActionMenuItems=function(extra){
   var that=this;
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   
   var rowData = extra.rowData;
   var deleteLink = this.findLink(rowData, "delete");
   var downloadLink = this.findLink(rowData, "content");
   var historyLink = this.findLink(rowData, "history");
   var updateLink = this.findLink(rowData, "update");
   var isUpdateEnabled = this.getCpbEnabled();
   var isLocked = rowData.lockOwner;
   var isLockedByCurrentUser = sas.risk.mrm.api.ContentManagementAPI.isCurrentUserLockOwner(this.getModel("cpb_data"), rowData);
   var forceLock = this.meta.canForceLock;
   var forceUnlock = this.meta.canForceUnlock;
   
   var enabledActions = [];
   
   // Update / properties
   if (!isUpdateEnabled || (isLocked && !isLockedByCurrentUser))
   {
      var propertiesItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.propertiesAction,
         hideOnReadonly : false,
         callback : $.proxy(that.actionRowProperties, this)
      });
      enabledActions.push(propertiesItem);      
   }
   else if(updateLink)
   {
      var updateItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.updateAction,
         callback : $.proxy(that.actionRowUpdate, this)
      });
      
      if (this.meta.canUpdateContent === undefined || this.meta.canUpdateContent){
         enabledActions.push(updateItem);      
      }
   }
   
   //Download
   if (downloadLink)
   {
      var downloadItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.downloadAction,
         hideOnReadonly : false,
         callback : $.proxy(that.actionRowDownload, this)
      });
      enabledActions.push(downloadItem);
      
      var copyLinkItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.copyLinkAction,
         hideOnReadonly : false,
         callback : $.proxy(that.actionRowCopyLink, this)
      });
      enabledActions.push(copyLinkItem);
   }
   
   // Lock / unlock
   if (isUpdateEnabled && updateLink && (!isLocked || (forceLock && !isLockedByCurrentUser)))
   {
      var lockItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.lockAction,
         callback : $.proxy(that.actionRowLockUnlock, this, true)
      });
      
      if (this.meta.canUpdateContent === undefined || this.meta.canUpdateContent){
         enabledActions.push(lockItem);      
      }
   }
   if (isUpdateEnabled && isLocked && (forceUnlock || isLockedByCurrentUser))
   {
      var unlockItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.unlockAction,
         callback : $.proxy(that.actionRowLockUnlock, this, false)
      });
      enabledActions.push(unlockItem);      
   }
   
   //Remove
   if (isUpdateEnabled && deleteLink && (!isLocked || isLockedByCurrentUser))
   {
      var deleteItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.deleteAction,
         callback : $.proxy(that.actionRowDelete, this)  
      });
      enabledActions.push(deleteItem);
   }
   
   //View history
   if (historyLink)
   {
      var historyItem = sas.risk.slimtable.util.RowActionUtil.createActionMenuItem({
         text : that.meta.viewHistoryAction,
         hideOnReadonly : false,
         callback : $.proxy(that.actionRowHistory, this)
     });
      
     if (this.meta.canUpdateContent === undefined || this.meta.canUpdateContent){
        enabledActions.push(historyItem);
     }
   }

   return enabledActions;
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowDownload=function(payload){
   var rowData = payload.rowData;
   if (rowData)
   {
      //find the download link and follow it
      sas.risk.mrm.api.ContentManagementAPI.downloadAttachmentContent(rowData);
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowCopyLink=function(payload){
   var rowData = payload.rowData;
   if (rowData)
   {
      //find the download link and copy to the clipboard
      sas.risk.mrm.api.ContentManagementAPI.copyAttachmentDownloadLink(rowData);
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTableSelectionChanged=function(){
   var enableDelete = false;
   var source=this.table.getSource();
   var indices=source.getSelections();
   if (indices.length) {
      var srcRows=source.getData();
      var enableDelete=true;
      for(var i=0;i<indices.length;i++){
         rowData=srcRows[indices[i]];
         var deleteLink = this.findLink(rowData, "delete");
         var isLocked = rowData.lockOwner;
         var isLockedByCurrentUser = sas.risk.mrm.api.ContentManagementAPI.isCurrentUserLockOwner(this.getModel("cpb_data"), rowData);
         enableDelete = enableDelete && (deleteLink && (!isLocked || isLockedByCurrentUser));
         if (!enableDelete) break;
      }
   }
   this.multiDeleteLink.setEnabled(enableDelete);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTargetDelete=function(){
   var source=this.table.getSource();
   var indices=source.getSelections();
   var srcRows=source.getData();
   var i,row,link,rows=[],links=[];
    
   for(var i=0;i<indices.length;i++){
       row=srcRows[indices[i]];
       link = this.findLink(row, "delete");
       if (link) {
          rows.push(row);
          links.push(link);
       }
   }
   this.doDelete(rows, links, source);      
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTargetAdd=function(){
   var source=this.table.getSource();
   var indices=source.getSelections();
   var srcRows=source.getData();
   var that=this;
   
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var viewData={
         create:true,
         meta:this.meta,
         model:this.getModel("cpb_data"),
         title:this.meta.addTitle
     };
     sas.risk.mrm.util.DialogManager.open("ContentPropertiesDialog",viewData,that.refreshTableContent,that);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTargetHTMLAdd=function(){
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var viewData={
         create:true,
         meta:this.meta,
         model:this.getModel("cpb_data"),
         title:this.meta.addRichTextTitle
     };
     sas.risk.mrm.util.DialogManager.open("ContentHTMLDialog",viewData,this.refreshTableContent,this);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTargetImplementationAdd=function(){
	var cpbObjectModel=this.getCpbForm().getCpbObjectModel();
	var rb = sas.risk.mrm.util.MRMUtil.getBundle();
	var viewData={
	   "remoteFileListingURL": this.getMeta().remoteFileListingURL,
	   "remoteFileTransferURL": this.getMeta().remoteFileTransferURL,
	   "groupNumber": this.getMeta().groupNumber,
	   "model": this.getModel("cpb_data"),
	   "bizObjectRK":cpbObjectModel.getBusinessObjectRK(),
	   "bizObjectETag":cpbObjectModel.getBusinessObjectETag(),
	   title:rb.getText("content.dialog.modelImplementation.files.list.txt")
	};
   sas.risk.mrm.util.DialogManager.open("ContentImplementationDialog",viewData,this.refreshTableContent,this);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowDelete=function(payload){
   var rowData = payload.rowData;
   var deleteLink = this.findLink(rowData, "delete");
   this.doDelete([rowData], [deleteLink]);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.doDelete=function(items, deleteLinks, source){
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var that = this;
   
   if (items && deleteLinks && items.length === deleteLinks.length && items.length > 0)
   {
      var callBackFn = function(action) {
         if(action==="CANCEL"){return;}
         that.table.setBusyIndicatorDelay(0);
         that.table.setBusy(true);
         
         var delDef = sas.risk.mrm.api.ContentManagementAPI.deleteAttachments(that.getModel("cpb_data"), that.meta.groupNumber, items, deleteLinks);
         
         delDef.done(function(){
            if (!that.meta.immediateSave) {
               that.fireChange();
            }
         }).fail(function(e){
            if (e.status && e.status === 404)
            {
               //The parent object no longer exists
               var errorJson = {"message" : that.meta.missingParentMsg};      
      	      sas.risk.common.widgets.MessageDetailsBox.error(errorJson, sas.config.appName);	
            }
            else
            {
               sas.ui.cpb3.CpbUtil.handleFail(e);
            }
         }).always(function(e){
            if (source) source.setSelections([]);
            that.refreshTableContent();
            that.table.setBusy(false);
         });
     };
      
     var labelTxt = jQuery.sap.formatMessage(this.meta.deleteConfirmation, [items[0].fileName]);
     var titleTxt = this.meta.deleteConfirmationTitle;
     
     if (items.length > 1)
     {
        labelTxt = jQuery.sap.formatMessage(this.meta.multiDeleteConfirmation, [items.length]); 
        titleTxt = this.meta.multiDeleteConfirmationTitle;      
     }
     
     sas.hc.m.MessageBox.warning(labelTxt, titleTxt, [ sas.hc.m.MessageBox.Action.DELETE, sas.hc.m.MessageBox.Action.CANCEL], null, callBackFn);
   }
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowLockUnlock=function(lockOrUnlock, payload){
   var rowData = payload.rowData;
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var that = this;
   var def = null;
   
   that.table.setBusyIndicatorDelay(0);
   that.table.setBusy(true);
   
   if (lockOrUnlock)
      def = sas.risk.mrm.api.ContentManagementAPI.lockAttachment(that.getModel("cpb_data"), that.meta.groupNumber, rowData, that.meta.canForceLock);
   else     
      def = sas.risk.mrm.api.ContentManagementAPI.unlockAttachment(that.getModel("cpb_data"), that.meta.groupNumber, rowData, that.meta.canForceUnlock);
   def.fail(function(e){
      if (e.status && e.status === 404)
      {
         //The parent object no longer exists
         var errorJson = {"message" : that.meta.missingParentMsg};      
	      sas.risk.common.widgets.MessageDetailsBox.error(errorJson, sas.config.appName);	
      }
      else
      {
         sas.ui.cpb3.CpbUtil.handleFail(e);
      }
   }).always(function(){
      that.table.doRefresh();
      that.table.setBusy(false);
   });
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowProperties=function(payload){
   var rowData = payload.rowData;
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var viewData={
         meta:this.meta,
         model:this.getModel("cpb_data"),
         attachment:rowData,
         update:false,
         title:this.meta.propertiesTitle
     };
     sas.risk.mrm.util.DialogManager.open("ContentPropertiesDialog",viewData,this);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowUpdate=function(payload){
   var rowData = payload.rowData;
   var isHTML=(rowData.fileExtension==="HTML" && this.shouldHandleRichText());
   if(isHTML && !this.getCpbEnabled()){
   	return this.actionRowDownload(payload);//download the HTML in readonly mode
   }   
   var rb = sas.risk.mrm.util.MRMUtil.getBundle();
   var that = this;
   var viewData={
         meta:this.meta,
         model:this.getModel("cpb_data"),
         attachment:rowData,
         update:true,
         title:this.meta.updateTitle
     };
     var contentDialog = isHTML ? "ContentHTMLDialog" : "ContentPropertiesDialog";
     if(contentDialog==="ContentHTMLDialog"){
   	  viewData.title=this.meta.updateRichTextTitle;
     }
     sas.risk.mrm.util.DialogManager.open(contentDialog,viewData,that.refreshTableContent,that);
};

sas.risk.mrm.components.ContentManagementComponent.prototype.actionRowHistory=function(payload){
   var rowData = payload.rowData;
   var historyLink = this.findLink(rowData, "history");
   if (historyLink && historyLink.href)
   {
      var rb = sas.risk.mrm.util.MRMUtil.getBundle();
      var viewData={
            meta:this.meta,
            model:this.getModel("cpb_data"),
            historyLink:historyLink,            
            title:this.meta.historyTitle,
            formattingKey:sas.risk.mrm.util.MRMUtil.buildDialogFormattingKey("ContentHistoryDialog",this.getCpbForm(),"ContentManagementComponent",this.getCpbName())
        };
        sas.risk.mrm.util.DialogManager.open("ContentHistoryDialog",viewData,this);
   }
}

sas.risk.mrm.components.ContentManagementComponent.prototype.actionTableRowClicked=function(e)
{
   //CLICKING ON ROW WILL DOWNLOAD
   var rowData = e.getSource().getSource().getData()[e.getParameter("rowIdx")];
   if(rowData.fileExtension==="HTML" && this.shouldHandleRichText()){
   	this.actionRowUpdate({"rowData": rowData});
   }else{
   	sas.risk.mrm.api.ContentManagementAPI.downloadAttachmentContent(rowData);
   }
};

//UTILS
sas.risk.mrm.components.ContentManagementComponent.prototype.findLink=function(item, name)
{
   var result;
   if (item && item.links)
   {
      result = _.find(item.links, function (link) {return link.rel === name});
   }
   return result;
}
//STATICS
sas.risk.mrm.components.ContentManagementComponent.create=function(fieldJson, modelId, cpbForm) {
   var settings=sas.ui.cpb3.WidgetBindingUtil.getBasicSettings(fieldJson,modelId,cpbForm);
   return new sas.risk.mrm.components.ContentManagementComponent($.extend(
       settings,
       {
      	 cpbValue:sas.ui.cpb3.WidgetBindingUtil.getDataBindingPath(modelId,'CONTENTATTACHMENTS',true),
      	 meta : fieldJson.meta,
 			 formattingKey :sas.risk.mrm.util.MRMUtil.buildFormattingKey(cpbForm,fieldJson.type,fieldJson.cpbName),
      	 visibleRows : fieldJson.visibleRows
       }
   ));
};
//FORMATTERS
sas.risk.mrm.components.ContentManagementComponent.formatter = {
	"JAVA.LANG.LONG_fileSize":new sas.risk.mrm.meta.formatter.FileSizeFormatter("JAVA.LANG.LONG_fileSize") 
};

sas.risk.slimtable.meta.ColumnFormatterRegistry.registerFactory(sas.risk.mrm.components.ContentManagementComponent.formatter,"ContentManagement");
