jQuery.sap.declare("sas.ui.cpb3.CpbUtil");

sas.ui.cpb3.CpbUtil={
	findCpbId:function(control){
		if(!control){return null;}
		if(control.getCpbId){
			return control.getCpbId();
		}
		return sas.ui.cpb3.CpbUtil.findCpbId(control.getParent());
	},
   findParent:function(child,parentClass){
   	for(var c=child;!!c.getParent();c=c.getParent()){
   		if(c.getParent() instanceof parentClass){
   			return c.getParent();
   		}
   	}
   	return null;
   },
   _wrapperRb:{
		getText : function(key, args){
			var val=null;
			if(sas.ui.cpb3.CpbUtil._rb && sas.ui.cpb3.CpbUtil._rb.getText){
				return sas.ui.cpb3.CpbUtil._rb.getText(key,args);
			}
			if(sas.ui.cpb3.CpbUtil._wrapperRb.rbJson){
				val=sas.ui.cpb3.CpbUtil._wrapperRb.rbJson[key];
			}
			if(!val){
				console.error("SlimTable Resource bundle missing : Key = " + key);
				return key;
			}
			return (args&&args.length)?jQuery.sap.formatMessage(val,args):val;
		}
	},
	setBundle:function(rb){
		sas.ui.cpb3.CpbUtil._rb=rb;
	},
	setBundleJson:function(rbJson){
		sas.ui.cpb3.CpbUtil._wrapperRb.rbJson=rbJson;
	},
	getBundle:function(){
		return sas.ui.cpb3.CpbUtil._wrapperRb;
	},
	_locale:null,
	getLocale:function(){
		return sas.ui.cpb3.CpbUtil._locale;
	},
	setLocale:function(locale){
		sas.ui.cpb3.CpbUtil._locale=locale;
	},
	_stringifyFilter:function(key,val){
		return (val===null)?undefined:val;
	},
	stringify:function(obj){
		return JSON.stringify(obj,sas.ui.cpb3.CpbUtil._stringifyFilter);
	},
	handleFail:function(e,jqxhr){
		console.error(arguments);
		var json=e.responseJSON||(jqxhr&&jqxhr.responseJSON);
		if(!json){
			var rb = sas.ui.cpb3.CpbUtil.getBundle();
			if(jqxhr&&jqxhr.status===404){
				json={message:rb.getText("message.error.404.txt")};
			}else{
				json={message:rb.getText("message.error.500.txt")};
			}
		}
		jQuery.sap.require("sas.risk.common.widgets.MessageDetailsBox");
    	sas.risk.common.widgets.MessageDetailsBox.error(json, sas.config.appName);	
   },
   _session:{},
   sessionSet:function(key,value){
   	sas.ui.cpb3.CpbUtil._session[key]=value;
   },
   sessionGet:function(key,remove){
   	var value=sas.ui.cpb3.CpbUtil._session[key];
   	if(remove){
   		delete sas.ui.cpb3.CpbUtil._session[key];
   	}
   	return value;
   },
   sessionClear:function(keyRoot){
   	sas.ui.cpb3.CpbUtil._session=_.pick(sas.ui.cpb3.CpbUtil._session,function(value,key,object){
   		return key.substr(0,keyRoot.length).toUpperCase() !== keyRoot.toUpperCase();
   	});
   },
   silentUpdateHash:function(newHash){
      var orig=hasher.changed.dispatch;
      hasher.changed.dispatch=function(){
      	hasher.changed.dispatch=orig;
         };
      top.location.hash=newHash;
   },
   _eventQueues:{},
   _storageEventListener:function(event){
   	var eventId=event.key;
   	var queue=sas.ui.cpb3.CpbUtil._eventQueues[eventId];
   	if(queue && event.newValue){
   		var message=JSON.parse(event.newValue);
   		if(message!==null){
   			queue.fireEvent(eventId,{payload:message});
   		}
   	}
   },
   attachStorageEvent:function(eventId,callback,scope){
   	var eventQueues=sas.ui.cpb3.CpbUtil._eventQueues;
   	if(!eventQueues[eventId]){
   		eventQueues[eventId]=new sap.ui.base.EventProvider()
   	}
   	eventQueues[eventId].attachEvent(eventId,callback,scope);
   },
   detachStorageEvent:function(eventId,callback,scope){
   	var eventQueues=sas.ui.cpb3.CpbUtil._eventQueues;
   	if(eventQueues[eventId]){
   		eventQueues[eventId].detachEvent(eventId,callback,scope);
   	}   	
   },
   fireStorageEvent:function(eventId,message,fireLocally){
   	localStorage.setItem(eventId,null);
   	localStorage.setItem(eventId,JSON.stringify(message));
   	if(fireLocally){
      	var eventQueues=sas.ui.cpb3.CpbUtil._eventQueues;
      	if(eventQueues[eventId]){
      		eventQueues[eventId].fireEvent(eventId,{payload:message});
      	}
   	}
   },
   _contextPath:top.location.pathname,
   getContextPath:function(){
   	return sas.ui.cpb3.CpbUtil._contextPath;
   },
   _contextQuery:top.location.search||"",
   getContextQuery:function(useAmpersand){
   	if(useAmpersand && sas.ui.cpb3.CpbUtil._contextQuery){
   		return "&"+sas.ui.cpb3.CpbUtil._contextQuery.substring(1);
   	}
   	return sas.ui.cpb3.CpbUtil._contextQuery;
   }
};
window.addEventListener('storage', sas.ui.cpb3.CpbUtil._storageEventListener, this);